; ************************************************
; ficacconvert.LSP         (ACAD2004 fr Windows)
; (fast IronCAD ACAD convertion)
;
; Program fhrt folgende Operationen durch:
; - Generierung von ACAD Standardlayern
; - Konvertieren von IronCAD Layern auf ACAD Layern
; - Lschen von unsichtbaren Linien hinter Krperkanten
; - Bereinigen der Datei
;
; Letzte nderung: 11.04.03
; 
; Autor:   W.xx
;



;**********************************************************
;**  Hauptprogramm
;**********************************************************

(defun c:ws_ficacconvert ()
   ;***** Elemente die konvertiert werden sollen auswhlen

   (command "_.zoom" "_e")
   (setq pkt1 (getvar "vsmin"))
   (setq pkt2 (getvar "vsmax"))

   (PRINC "\n***********************************************************")
   (PRINC "\n***     IronCAD Layer in Genius Layer umwandeln         ***")
   (PRINC "\n***                    ACHTUNG !!                       ***")
   (PRINC "\n***         (funktioniert nicht fr Blcke              ***")
   (PRINC "\n***    - alle Blcke vorher aufbrechen                  ***")
   (PRINC "\n***    - alle Plinien vorher aufbrechen                 ***")
;   (PRINC "\n***    - lscht alle Kreise und Bgen auf Layer 3 + 4   ***")
   (PRINC "\n***********************************************************")
   (ALERT "\nIronCAD Layer in Genius Layer umwandeln
           \n---------------------------------------
           \n- alle Blcke vorher aufbrechen
           \n- alle Gewindeolylinien vorher aufbrechen
           \nStart mit < RETURN > ")


;   (prompt "\nZu konvertierende Elemente auswhlen")
;   (setq pkt1 (getpoint "\nLinke untere Ecke von Auswahlfenster whlen"))
;   (setq pkt2 (getcorner pkt1 "\nRechte obere Ecke von Auswahlfenster whlen"))

   ;*********************************************************
   ;**  Alle Blcke in Auswahlfenster aufbrechen
   ;*********************************************************
;   (command "_.explode" "_.c" pkt1 pkt2 "")
;   (command "_.explode" "_.c" pkt1 pkt2 "")
;   (command "_.explode" "_.c" pkt1 pkt2 "")

;   (setq asatz (SSADD))

;   (setq asatz "")
   (setq asatz (ssget "_W" pkt1 pkt2))   ;Elemente Variable zuweisen

   (setq asatz (ssget "_ALL"))   ;Elemente Variable zuweisen

   (setq alen 0)
   (SETQ alen  (SSLENGTH asatz))               ;Auswahlsatz Lnge bestimmen und speichern

   ;***** Aufruf der Unterfunktionen
   (create_am6pplayer)                         ;alle AM6PP-Grundlayer einschalten
   (ironcad_layerzuweisung)                    ;IronCAD Layer auf ACAD Layer konvertieren
   (clean_edge)                                ;verdeckte Linien entfernen

   (prompt "\n****************  Zeile 6 ************")    

;   (clean_thread)                              ;Gewindedarstellung korrigieren

   ;***** Datei bereinigen
   (prompt "\n****************  Zeile 7 ************")    
   (command "_layer" "se" "AM_0" "")           ;Layer AM_0 als aktiven Layer setzten
   (prompt "\n****************  Zeile 8 ************")    
   (command "_purge" "AL" "" "N")             ;Bereinigen alles
   (prompt "\n****************  Zeile 9 ************")    
)

;**********************************************************
;**  Unterroutine zum generieren der Auotcad Mechanical 6
;**  Power Pack Layern
;**********************************************************

(defun create_am6pplayer()
  (command "_-amlayer" "_o" "CON1")
  (command "_-amlayer" "_o" "CON2")
  (command "_-amlayer" "_o" "CON3")
  (command "_-amlayer" "_o" "HIDW")
  (command "_-amlayer" "_o" "HIDN")
  (command "_-amlayer" "_o" "HLIN")
  (command "_-amlayer" "_o" "DILI")
  (command "_-amlayer" "_o" "TXT3")
  (command "_-amlayer" "_o" "CENW")
  (command "_-amlayer" "_o" "CENN")
  (command "_-amlayer" "_o" "HATC")
  (command "_-amlayer" "_o" "VPLI")
  (command "_-amlayer" "_o" "PHAN")
  (command "_layer" "M" "AM_0" "")                ;Layer AM_0 als aktiven Layer setzten
  (command "_layer" "_OFF" "AM_9" "")              ;Layer AM_9 ausschalten
  (command "_layer" "_OFF" "AM_9N" "")             ;Layer AM_9N ausschalten
)


;**********************************************************
;**  Unterroutine zur Convertierung von IronCAD Layern
;**********************************************************

(defun ironcad_layerzuweisung()  

   (PRINC "\n***********************************************************")
   (PRINC "\n***     IronCAD Layer in Genius Layer umwandeln         ***")
   (PRINC "\n***                    ACHTUNG !!                       ***")
   (PRINC "\n***         (funktioniert nicht fr Blcke              ***")
   (PRINC "\n***    - alle Blcke vorher aufbrechen                  ***")
   (PRINC "\n***    - lscht alle Kreise und Bgen auf Layer 3 + 4   ***")
   (PRINC "\n***********************************************************")
   
;   (command "_insert" "w:\\wllisp\\Grundlayer_AM6PP.dwg" (list 0 0 0) "" "" "")
   
;   (setq asatz "")                 ;Auswahlsatz fr zu konvertierende Elemente
;   (prompt "\nZu konvertierende Elemente whlen  ")
;   (SETQ asatz (SSGET))            ;Elemente whlen 

   (setq alauf1 0)                  ;Zhlervariable von Auswahlsatz auf 0 setzen
   (setq alen1 0)                   ;Auswahlsatzlnge auf 0 setzen
   (SETQ alen1  (SSLENGTH asatz))  ;Auswahlsatz Lnge bestimmen und speichern 

   ;** Definition der zu ndernden Layer **

;   (if (/= (setq auswahlsatz (ssget "X" '((8 . "050")))) nil)
;      (command "_CHANGE" auswahlsatz "" "_PROPERTIES" "_LAYER" "AM_0" "_COLOR" "_BYLAYER" "_LTYP" "_BYLAYER" "")
;   )
;   (if (/= (setq auswahlsatz (ssget "X" '((8 . "BEMASSUNG")))) nil)
;      (command "_CHANGE" auswahlsatz "" "_PROPERTIES" "_LAYER" "AM_5" "_COLOR" "_BYLAYER" "_LTYP" "_BYLAYER" "")
;   )
;   (if (/= (setq auswahlsatz (ssget "X" '((8 . "ALINIEN")))) nil)
;      (command "_CHANGE" auswahlsatz "" "_PROPERTIES" "_LAYER" "AM_7" "_COLOR" "_BYLAYER" "_LTYP" "_BYLAYER" "")
;   )


   (if (/= (setq t1 (ssget "X" '((8 . "AM_0")))) nil)
     (progn
        (command "_amjoin" "" (ssget "X" '((8 . "AM_0"))) "")
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_0" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_1")))) nil)
     (progn
        (command "_amjoin" "" (ssget "X" '((8 . "AM_1"))) "")
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_1" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_2")))) nil)
     (progn
        (command "_amjoin" "" (ssget "X" '((8 . "AM_2"))) "")
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_2" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_3")))) nil)
     (progn
        (command "_amjoin" "" (ssget "X" '((8 . "AM_3"))) "")
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_3" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_4")))) nil)
     (progn
        (command "_amjoin" "" (ssget "X" '((8 . "AM_4"))) "")
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_4" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_5")))) nil)
     (progn
        (command "_dim" "neutext" "<>" (ssget "X" '((8 . "AM_5"))) "" "_EXIT") 
                 ;Alle Formatierungszeichen aus Bemaung entfernen
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_7")))) nil)
     (progn
        (command "_amjoin" "" (ssget "X" '((8 . "AM_7"))) "")
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_7" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((8 . "AM_8")))) nil)
     (progn
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_8" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   )
   (if (/= (setq t1 (ssget "X" '((0 . "ARC") (8 . "AM_4") (6 . "DASH")))) nil)
     (progn
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_4" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   ) 
   (if (/= (setq t1 (ssget "X" '((8 . "AM_3")))) nil)
     (progn
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_3" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   ) 
   (if (/= (setq t1 (ssget "X" '((0 . "LINE") (8 . "AM_0")))) nil)
     (progn
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_0" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   ) 
   (if (/= (setq t1 (ssget "X" '((0 . "LINE") (8 . "AM_4")))) nil)
     (progn
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_3" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   ) 
   (if (/= (setq t1 (ssget "X" '((0 . "POYLINE") (8 . "AM_4")))) nil)
     (progn
        (command "_.CHANGE" t1 "" "_PROPERTIES" "_LAYER" "AM_3" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
     )
   ) 
)


;**********************************************************
;**  Unterroutine zum subern von Krperkanten von doppelten Linien
;**  auf Layer AM_03 (unsichtbare Kanten) und AM_07 (Mittellinien)
;**********************************************************

(defun clean_edge()
         (prompt "\n*************************************** ws_cleanedge.lsp **5/02WS**")
         (prompt "\n** Funktion zum Lschen aller Elemente auf Layer AM_3 die sich   **")
         (prompt "\n** innerhalb von Elementen auf Layer AM_0 befinden               **")
         (prompt "\n** (funktioniert nur bei Linien; Kreisen; Bgen)                 **")
         (prompt "\n*******************************************************************")
         (SETQ w270 4.71238898)
         (SETQ w180 3.141592654)
         (SETQ w90 1.570796327)
         (SETQ w45 0.785398163)
         (SETQ w135 2.35619449)
         (SETQ w225 3.926990817)
         (SETQ w315 5.497787144)
         (SETQ r1 0.25)   ;Abstand von Fangfenster von Linie
         (setq alauf 0)   ;Zhlvariable von Auswahlsatz
         (setq os (getvar "osmode"))  ;Fangmodus sichern      

         ;********* Elemente auswhlen 
         (prompt "\n****************  Zeile 1 ************")
          
         (prompt "\nZu subernde Elemente auswhlen")

         (prompt "\n****************  Zeile 2 ************")  

         (setq asatz (SSADD))
         (setq alen 0)

         (setq asatz (ssget "_W" pkt1 pkt2))         ;Elemente Variable zuweisen, Fensterpunkte von Hauptprgramm
         (prompt "\n****************  Zeile 3 ************")  

         (SETQ alen  (SSLENGTH asatz))               ;Auswahlsatz Lnge bestimmen und speichern
         (setvar "osmode" 0)                         ;Fang ausschalten 
         (setvar "orthomode" 0)                      ;Ortho ausschalten 
         (prompt "\n****************  Zeile 4 ************")  

         (WHILE (< alauf alen)
           (progn
             (SETQ e (ENTGET (SSNAME asatz alauf)))  ;Element Variable e zuweisen
             (if (AND (= (cdr (assoc 0 e)) "LINE") (= (cdr (assoc 8 e)) "AM_0"))                 
               (progn  
                  (SETQ startpkt (cdr (assoc 10 e)))                        
                  (SETQ endpkt (cdr (assoc 11 e)))                    
                  (SETQ lwinkel (ANGLE startpkt endpkt))
                  (SETQ p1 (polar startpkt (+ lwinkel w45) -0.25))           ;Eckpunkt berechnen
                  (SETQ p2 (polar startpkt (- lwinkel w45) -0.25))           ;Eckpunkt berechnen
                  (SETQ p3 (polar endpkt (- lwinkel w45) 0.25))              ;Eckpunkt berechnen
                  (SETQ p4 (polar endpkt (+ lwinkel w45) 0.25))              ;Eckpunkt berechnen
                  (setq asatz1 (SSADD))
                  (SETQ asatz1 (SSGET "_WP" (list p1 p2 p4 p3) (list (CONS 8 "AM_3"))))
                  (if (/= asatz1 nill) (command "_erase" asatz1 ""))                                  
               )
             )
             (if (AND (= (cdr (assoc 0 e)) "CIRCLE") (= (cdr (assoc 8 e)) "AM_0"))                 
               (progn  
                  (SETQ Zentrumpkt (cdr (assoc 10 e)))
                  (SETQ Radius (cdr (assoc 40 e)))
                  (SETQ ptmp (polar Zentrumpkt w180 (+ Radius 0.25)))        ;Eckpunkt berechnen
                  (SETQ p1 (polar ptmp w90 (+ Radius 0.25)))                 ;Eckpunkt berechnen
                  (SETQ p2 (polar ptmp w270 (+ Radius 0.25)))                ;Eckpunkt berechnen
                  (SETQ ptmp (polar Zentrumpkt 0 (+ Radius 0.25)))           ;Eckpunkt berechnen
                  (SETQ p3 (polar ptmp w90 (+ Radius 0.25)))                 ;Eckpunkt berechnen
                  (SETQ p4 (polar ptmp w270 (+ Radius 0.25)))                ;Eckpunkt berechnen
                  (setq asatz1 (SSADD))
                  (SETQ asatz1 (SSGET "_WP" (list p1 p2 p4 p3) (list (CONS -4 "<AND") 
                                                                        (CONS 8 "AM_3")
                                                                        (CONS 40 Radius)
                                                                     (CONS -4 "AND>"))))
                  (if (/= asatz1 nill) (command "_erase" asatz1 ""))                                  
               )
             )
            (if (AND (= (cdr (assoc 0 e)) "ARC") (= (cdr (assoc 8 e)) "AM_0"))                 
               (progn  
                  (SETQ Zentrumpkt (cdr (assoc 10 e)))
                  (SETQ Radius (cdr (assoc 40 e)))
                  (SETQ ptmp (polar Zentrumpkt w180 (+ Radius 0.25)))        ;Eckpunkt berechnen
                  (SETQ p1 (polar ptmp w90 (+ Radius 0.25)))                 ;Eckpunkt berechnen
                  (SETQ p2 (polar ptmp w270 (+ Radius 0.25)))                ;Eckpunkt berechnen
                  (SETQ ptmp (polar Zentrumpkt 0 (+ Radius 0.25)))           ;Eckpunkt berechnen
                  (SETQ p3 (polar ptmp w90 (+ Radius 0.25)))                 ;Eckpunkt berechnen
                  (SETQ p4 (polar ptmp w270 (+ Radius 0.25)))                ;Eckpunkt berechnen
                  (setq asatz1 (SSADD))
                  (SETQ asatz1 (SSGET "_WP" (list p1 p2 p4 p3) (list (CONS -4 "<AND") 
                                                                        (CONS 8 "AM_3")
                                                                        (CONS 40 Radius)
                                                                     (CONS -4 "AND>"))))
                  (if (/= asatz1 nill) (command "_erase" asatz1 ""))                  
               )
             )
             (princ)
             (setq alauf (+ alauf 1))
           )
         )
       (PRINC)
       (setvar "osmode" os)    ;Objektfang zurcksetzten
       (setq alauf1 0)                             ;Zhler fr Elemente wieder zurcksetzen
       (prompt "\n****************  Zeile 5 ************")    
)


;**********************************************************
;**  Unterroutine zum Lschen von allen Kreisen auf
;**  AM_4 und ersezten durch 3/4 Bgen
;**********************************************************

(defun clean_thread()
   (prompt "\n***************************************** ws_cthread.lsp **4/03WS**")
   (prompt "\n**   Funktion lscht Kreise auf Layer AM_4 und ersetzt diese     **")
   (prompt "\n**   Kreise durch 3/4 Bgen                                      **")
   (prompt "\n*******************************************************************")

   (command "_-amlayer" "_o" "CENW")   ;Erstelle Achslinienlayer 
   (command "_-amlayer" "_o" "HIDW")   ;Erstelle unischtbare Layer

   (setq os (getvar "osmode"))         ;Fangmodus sichern
   (setq la (getvar "clayer"))         ;aktueller Layer sichern

   (setq asatz1 (SSADD))               ;Auswahlsatz fr zu konvertierende Elemente
   (setq asatz2 (SSADD))               ;Auswahlsatz fr zu konvertierende Elemente

;   (prompt "\nElemente whlen ")
;   (SETQ asatz1 (SSGET))               ;Elemente whlen 

   (setq asatz (ssget "_W" pkt1 pkt2))         ;Elemente Variable zuweisen, Fensterpunkte von Hauptprgramm
  
   ;***************************
   (command "_.layer" "_se" "AM_4" "") ;Hilfslinienlayer einschalten
   (setvar "OSMODE" 0)                 ;Objektfang ausschalten
   ;***************************

   (setq maxradius 0.0)                ;grter Radius aus gewhlten Elementen suchen
   (setq elradius 0.0)                 ;Radius von Elementen 

   (setq alauf1 0)                     ;Zhlervariable von Auswahlsatz auf 0 setzen
   (setq alen1 0)                      ;Auswahlsatzlnge auf 0 setzen
   (SETQ alen1  (SSLENGTH asatz1))     ;Auswahlsatz Lnge bestimmen und speichern

   (WHILE (< alauf1 alen1)
     (progn
       (SETQ e1 (ENTGET (SSNAME asatz1 alauf1)))  ;Element Variable e1 zuweisen
          (if (AND (= (cdr (assoc 0 e1)) "CIRCLE") (= (cdr (assoc 8 e1)) "AM_4"))
            (progn  
              (SETQ kreiszentrum (cdr (assoc 10 e1)))
              (SETQ kreisradius (cdr (assoc 40 e1)))
              (command "_erase" (cdr (assoc -1 e1)) "")  
              (SETQ arcstart (polar kreiszentrum (* (/ pi 18) 26) kreisradius))
              (SETQ arcend (polar kreiszentrum (* (/ pi 18) 17) kreisradius))
              (command "_.arc" "_C" kreiszentrum arcstart arcend)          
            )
          )
          (if (AND (= (cdr (assoc 0 e1)) "LINE") (= (cdr (assoc 8 e1)) "AM_4"))
            (progn  
              (SSADD (cdr (assoc -1 e1)) asatz2) 
            )
          )
       (setq alauf1 (+ alauf1 1))
     )
   )
   (setq alauf1 0)                  ;Zhler fr Elemente wieder zurcksetzen  

   (setvar "osmode" os)             ;Fangmodus wieder herstellen

   (command "_.layer" "_se" la "")  ;aktuellen Layer wieder herstellen

   (command "_.CHANGE" asatz2 "" "_PROPERTIES" "_LAYER" "AM_3" "_COLOR" "_BYLAYER" "_LTYPE" "_BYLAYER" "")
)

;**********************************************************
;**************  Fehlerbehandlungs-Routine ****************
;**********************************************************

(defun *ERROR* (emsg)
  (setvar "cmddia" 1)
  (setvar "filedia" 1)
  (PRINC (STRCAT "Fehler, " emsg))
  (PRINC)
)
